//+------------------------------------------------------------------+
//|                                                      iBroker.mq4 |
//|                              (lsv)|
//|                                             .. 15.03.15 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "Fedor10_10@mail.ru"
#property version   "1.00"
#property description "iBroker"
#property strict
#property indicator_separate_window
//---- indicator settings
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_level1  0.0
//---- input parameters
input uchar  Step    =1;    // 
input float  Probab  =90.0; //%  
input float  forg    =5.0;  //%  
input uchar  PeriodMA=1;    //  =1  
input uchar  Stop    =1;    //StopLoss  TakeProfit
char   sl[2048,1000];       //       
uchar  StopLev,Spread;
ushort tr,w,mn,post[2048],Perc;
short  mb,ms,Prib[2048];
int    i,Pr[12],cena[2048,1000],MAt[250];
float  forgt,Prob,rost[2048],spad[2048],sum[2048];
double Maxb[],Maxs[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit(void)
  {
//---- 2 indicator buffers mapping
   SetIndexBuffer(0,Maxb);
   SetIndexBuffer(1,Maxs);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
//--- indicator buffers mapping
   StopLev=(uchar)MarketInfo(Symbol(),MODE_STOPLEVEL);//   -/-  
   Spread=(uchar)MarketInfo(Symbol(),MODE_SPREAD);//
   forgt=(float)(1.0-forg/100.0);//    
   Prob=(float)(Probab/100.0);//    
//---
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----
   int limit=rates_total-prev_calculated;
   for(i=0; i<limit; i++)
     {
      Maxb[i]=mb;//    BUY
      Maxs[i]=ms;//    SELL
      mb=0; ms=0;//   
     }
//---- main loop
   int Price=(int)(/*    */Close[0]/Point);//     
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
   int MA;//    PeriodMA
   for(tr=PeriodMA-1; tr>0; tr--)
     {
      MAt[tr]=MAt[tr-1];//       
      MA+=MAt[tr];// 
     }
   MAt[0]=Price;
   MA+=MAt[0];
   MA/=PeriodMA;//  
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
   if(MathAbs(MA-Pr[0])>=Step/*    */)//     
     {
      Pr[3]=Pr[2]; Pr[2]=Pr[1]; Pr[1]=Pr[0];// 
      Pr[0]=MA;//   
     }
//+------------------------------------------------------------------+
   if(MathAbs(MA-Pr[4])>=Step+1/*    */)//     
     {
      Pr[7]=Pr[6]; Pr[6]=Pr[5]; Pr[5]=Pr[4];// 
      Pr[4]=MA;//   
     }
//+------------------------------------------------------------------+
   if(MathAbs(MA-Pr[8])>=Step+2/*    */)//     
     {
      Pr[11]=Pr[10]; Pr[10]=Pr[9]; Pr[9]=Pr[8];// 
      Pr[8]=0;//   
     }
//+------------------------------------------------------------------+
//|  ( )                             |
//+------------------------------------------------------------------+
   Perc=0; mn=1;
   for(tr=7; tr>0; tr--)
     {//     ,      
      if(Pr[tr-1]>Pr[tr]) Perc=Perc+mn;//(   )   9 
      mn=mn*2;//   2048(2^MemPc-1)
     }
//+------------------------------------------------------------------+
//|   (    Perc)|
//+------------------------------------------------------------------+
   if(cena[Perc,post[Perc]]!=0) post[Perc]++;//   ( )  
                                             //(       )
   cena[Perc,post[Perc]]=Price;//  (  )(  )
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
   for(tr=0; tr<mn; tr++)// ()
     {
      for(w=0; w<=post[tr]; w++)//  
        {
         if(cena[tr,w]>0)//  
           {
            //+------------------------------------------------------------------+
            //|                                        |
            //+------------------------------------------------------------------+
            if((Price-cena[tr,w])>Stop && sl[tr,w]==0)
               sl[tr,w]++; //             
            if((Price-cena[tr,w])>(Stop+Spread))//    
              {
               if(sl[tr,w]<0) {rost[tr]--; Prib[tr]--;}//      (  )
               else {rost[tr]++; Prib[tr]++;};// (  )
               rost[tr]*=forgt;// 
               spad[tr]*=forgt;// 
               sum[tr]=rost[tr]+spad[tr];// 
               cena[tr,w]=0;//  (  )
               sl[tr,w]=0;// 
              }
            if((cena[tr,w]-Price)>Stop && sl[tr,w]==0)
               sl[tr,w]--; //             
            if((cena[tr,w]-Price)>(Stop+Spread))//    
              {
               if(sl[tr,w]>0) {spad[tr]--; Prib[tr]++;}//      (  )
               else {spad[tr]++; Prib[tr]--;}// (  )
               spad[tr]*=forgt;// 
               rost[tr]*=forgt;// 
               sum[tr]=rost[tr]+spad[tr];// 
               cena[tr,w]=0;//  (  )
               sl[tr,w]=0;// 
              }
            //+------------------------------------------------------------------+
            //|              |
            //+------------------------------------------------------------------+
            if(rost[tr]>0 && spad[tr]>0)//  
              {
               if(rost[tr]/sum[tr]>Prob&&Prib[tr]>0.0) {mb+=Prib[tr]; Prib[tr]=0;}//     BUY
               if(spad[tr]/sum[tr]>Prob&&Prib[tr]<0.0) {ms+=Prib[tr]; Prib[tr]=0;}//     SELL
              }
           }
         //+------------------------------------------------------------------+
         //|   ()                        |
         //+------------------------------------------------------------------+
         if(post[tr]>0)//    
           {
            if(cena[tr,w]==0)//  
              {
               cena[tr,w]=cena[tr,w+1];
               cena[tr,w+1]=0;//    
               sl[tr,w]=sl[tr,w+1];
               sl[tr,w+1]=0;//     
              }//     -   
            if(cena[tr,post[tr]]==0) post[tr]--;
           }
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
